package com.backstopsolutions.activemqtest;

import java.util.Enumeration;

import javax.annotation.Resource;
import javax.ejb.ActivationConfigProperty;
import javax.ejb.EJBException;
import javax.ejb.MessageDriven;
import javax.ejb.MessageDrivenBean;
import javax.ejb.MessageDrivenContext;
import javax.ejb.TransactionAttribute;
import javax.ejb.TransactionAttributeType;
import javax.ejb.TransactionManagement;
import javax.ejb.TransactionManagementType;
import javax.jms.JMSException;
import javax.jms.MapMessage;
import javax.jms.Message;
import javax.jms.MessageListener;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.jboss.ejb3.annotation.ResourceAdapter;

@MessageDriven(name = "MapProcessorBean",
        activationConfig =
              {
                 @ActivationConfigProperty(propertyName = "destinationType", propertyValue = "javax.jms.Queue"),
                 @ActivationConfigProperty(propertyName = "destination", propertyValue = "queue.mapqueue"),
                 @ActivationConfigProperty(propertyName = "acknowledgeMode", propertyValue = "Auto-acknowledge")
              })
@TransactionManagement(value= TransactionManagementType.CONTAINER)
@TransactionAttribute(value= TransactionAttributeType.REQUIRED)
@ResourceAdapter("hornetq-ra.rar")
public class MapProcessorBean implements MessageDrivenBean, MessageListener {
    @Resource
    protected MessageDrivenContext ctx;

    Log logger = LogFactory.getLog(MapProcessorBean.class);

    public void setMessageDrivenContext(MessageDrivenContext messageDrivenContext) {
        this.ctx = messageDrivenContext;
    }

    public void ejbRemove() throws EJBException {}
    
    public void onMessage(Message msg) {
        MapMessage mapMsg = (MapMessage) msg;
        try {
            logger.info("Received Message: " + mapMsg.getJMSMessageID());
            for(Enumeration e = mapMsg.getMapNames(); e.hasMoreElements(); ) {
                String name = (String) e.nextElement();
                logger.info("\t" + name + " = " + mapMsg.getObject(name));
            }
        } catch (JMSException jmse) {
            logger.error("Failed to get the content of the message!", jmse);
        }
    }
}
